#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"psort.h"

unsigned short	*j_table;					/* for special compare strings	*/
static uchar	*j_table2;					/* the same as above			*/

#define	MJ_TYPE		0x000f
#define	MJ_LINE		0x00ff
#define	MJ_KANA		0x4000
#define	MJ_O		0x0001
#define	MJ_S		0x0002
#define	MJ_I		0x0003
#define	MJ_B		0x0004
#define	MJ_0		0x0005
#define	MJ_1		0x0006
#define	MJ_BGET		0x0007
#define	MJ_C		0x0008
#define	MJ_EQ		0x0100
#define	MJ_EQL		0x0010
#define	MJ_CONT		0x0020

#ifdef	KANJI
unsigned short	j_k_start;					/* KANA table start				*/
unsigned short	j_k_end;					/* KANA table start				*/

#define	MJ_MAX_H	64
#define	MJ_MAX_BOW	16

#define	J_STEP0		0x0100
#define	J_STEP1		0x0020
#define	J_STEP2		0x0008
#define	J_ORD1		(J_STEP1-1)
#define	J_ORD2		(J_STEP2-1)

#define	J_SMAX		0x0100
#define	J_OSHIFT	(MJ_MAX_H<<7)
#define	J_NSHIFT	((MJ_MAX_H<<7) + 0x100)
#define	J_SHIFT		0x0100
#define	J_SORD		0x000f
#define	J_KANA		0x0030
#define	J_IGNORE	0x0001

#define	J_DONE		0x0100
#define	J_SKIP		0x0040
#define	J_BOWEL		0x0010
#define	J_DAKU		0x0020
#define	J_NDAKU		0x0030

#ifdef	EUC
#define	MAX_JTBL	0x3000
#define	LAST_CODE	0xfefe
#else
#define	MAX_JTBL	0x3d00
#define	LAST_CODE	0xfcfc
#endif

void makeJtable(uchar *f)
{
	uint	ch, cho, depth, tmp, ch0, ch1, max_b, max_h, max_j, max_n;
	uint	i, jline, count, count1, count2, count3, countc;
	uint	flag, skip;
	uchar	*s;
	FILE	*fp;

	unsigned short	j_stable[J_SORD+1];
	unsigned short	j_stable2[J_SORD+1];
	unsigned short	h_table0[MJ_MAX_H];
	unsigned short	h_table1[MJ_MAX_H];
	unsigned short	h_tableb[MJ_MAX_H];
	unsigned char	bows[MJ_MAX_BOW];
	unsigned short	ad_bows[MJ_MAX_BOW];

	ch = depth = flag = count1 = count2 = count3 = countc = max_b = max_h
    = max_j = jline = skip = 0;

	count = J_SMAX;
	max_n = J_NSHIFT;

	if((fp = read_open(f, "psort.tbl")) == NULL){
		fprintf(stderr, "Cannot open J-table file\n");
		exit(2);
	}

	for(i=0; i < MJ_MAX_H; i++)
		h_table0[i] = h_table1[i] = h_tableb[i] = 0;
	for(i=0; i < J_SORD+1; i++)
		j_stable[i] = 0;
	j_table = (unsigned short *)xmalloc(MAX_JTBL*sizeof(unsigned short));
	j_table2 = (uchar *)xmalloc(MAX_JTBL*sizeof(uchar));
	for(i=0; i < MAX_JTBL; i++)
		j_table[i] = j_table2[i] = 0;

	while(fgets(reg_buf, REG_size, fp) != NULL){
		jline++;
		if(reg_buf[0] <= ' ')
			continue;
		flag &= ~MJ_LINE;
		if(reg_buf[REG_size-1]){
			fprintf(stderr, "Too long line in %s\n", fname);
			exit(1);
		}
		modify_reg(reg_buf, 2);
		for(s = &reg_buf[0] ; ; ){
			cho = ch;
			switch(ch = *s++){
				case '\\':
				  switch(ch = *s++){
					case 'O':
						flag |= MJ_O;
top:					if((s - &reg_buf[0]) != 2){
err:						fprintf(stderr, 
								"Error in J-order file(%d):", jline);
							fp_out = stderr;
							Fputs(reg_buf);
							exit(2);
						}
						continue;

					case 'S':
						flag |= MJ_S;
						goto top;

					case 'C':
						flag |= MJ_C;
						goto top;

					case 'I':
						flag |= MJ_I;
						goto top;

					case 'J':
						flag += MJ_KANA;
						if(flag & MJ_KANA){
							if(j_k_start) goto err;
							j_k_start = count;
						}
						goto top;

					case 'D':
						if(!(flag & MJ_KANA))
							goto err;
						switch(ch = *s++){
							case 'B':
								flag |= MJ_B;
top2:							if((s - &reg_buf[0]) != 3)
									goto err;
								continue;

							case '0':
								flag |= MJ_0;
								goto top2;

							case '1':
								flag |= MJ_1;
								goto top2;

							deafult:
								goto err;
						}

					case 'E':
						ch = MAX_JTBL -1;
						goto get_code;

					case 'Q':
						goto end;

					case 'N':
						ch = max_n++;
						if(max_n & 0x20)
							max_n += 0xe0;
						goto get_code;

					case '0':
						if((ch = *s++) != 'x' && ch != 'X')
							goto err;
						ch = 0;
						for(;;s++){
							if(isdigit(tmp = *s))
								ch = (ch << 4) + tmp - '0';
							else{
								tmp = (tmp | 0x20) - ('a' - 10);
								if(tmp >= 10 && tmp < 16)
									ch = (ch<<4) + tmp;
								else break;
							}
						}
#ifdef	EUC
						if(ch >= 0x100)
							ch |= 0x8080;
						else if(ch & 0x80)
							ch |= (EUC_KANA<<8);
						if(ch >= 0x8e00){
							if(ch >= 0x9100 && ch <= 0xfeff)
								ch = ((ch - 0x8f00)>>1)|(ch & 0x7f);
							else if(ch >= 0xe000 && ch <= 0xfcff)
								ch = ((ch - 0x8e00)>>1)|(ch & 0x7f);
						}
#else
						if(ch >= 0x100)
							ch = jtosj(ch);
						if(ch >= 0x8100){
							if(ch <= 0x9fff)
								ch -= 0x8000;
							else if(ch >= 0xe000 && ch <= 0xfcff)
								ch -= 0xc000;
						}
#endif
					case '(':
					case '[':
					case ']':
					case '-':
					case '=':
					case ')':
					case '\\':
						goto get_code;

					case 0:
						goto err;

					default:
						if(flag & MJ_KANA){
							if(depth > 0){
								if(flag & MJ_TYPE)	goto err;
								bows[max_b] = ch;
								flag |= MJ_BGET;
								continue;
							}else{
								if(!max_h || depth)	goto err;
								h_tableb[max_h-1] = ch;
								continue;
							}
						}else
							goto err;
				}							/* End of // */

			case '(':
				if(depth == 1){
					skip |= 2;
					depth++;
				}
				goto up;

			case '[':
				if(depth == 0){
					skip |= 1;
					depth++;
				}
up:				if(depth++ >= 3) goto err;
				if(count3){
					count3 = 0;
					count2++;
				}
				if(depth == 3) continue;
				if(count2){
					count2 = 0;
					count1++;
				}
				if(depth == 2) continue;
				if(count1){
					count++;
					count1=0;
				}
				continue;

			case ')':
				if(depth == 3  && (skip & 2)){
					depth--;
					skip &= ~2;
				}
				goto down;

			case ']':
				if(depth == 2 && (skip & 1)){
					depth--;
					skip &= ~1;
				}
down:			if(depth-- <= 0) goto err;
				if(depth == 2){
					count3 = 0;
					if((count2 += J_STEP2) >= J_STEP1)
						goto err;
				}else if(depth == 1){
					count2 = count3 = 0;
					if((count1 += J_STEP1) >= J_STEP0)
						goto err;
				}else{
					count1 = count2 = count3 = 0;
					count++;
					if((flag & MJ_KANA) && ++max_h >= MJ_MAX_H)
						goto err;
				}
				continue;

			case '-':
				flag |= MJ_CONT;
				continue;

			case '=':
				flag |= ((s - &reg_buf[0]) == 1)?MJ_EQL:MJ_EQ;
				continue;

			case 0:
				goto next_l;

			default:
				if(ch <= ' ')
					continue;
				if(*s){
#ifdef	EUC
					if(ch >= 0x8e){
						if(ch >= 0x91 && ch <= 0xfe)
							ch = ((ch - 0x8f)<< 7) + (*s++ & 0x7f);
						else if(ch <= 0x8f)
							ch = ((ch - 0x8e)<< 7) + (*s++ & 0x7f);
					}
#else
					if(ch >= 0x81){
						if(ch <= 0x9f)
							ch = ((ch - 0x80)<<8) + *s++;
						else if(ch >= 0xe0 && ch <= 0xfc)
							ch = ((ch - 0xc0)<<8) + *s++;
					}
#endif
				}
get_code:		if(ch >= MAX_JTBL)	goto err;
				tmp = (flag & MJ_CONT)?(cho + 1):ch;
				for( ; tmp <= ch; tmp++){
					switch(flag & MJ_TYPE){
						case MJ_O:
							if(max_j > J_SORD)	goto err;
							j_stable2[max_j++] = ch;
							continue;

						case MJ_C:
							if((j_table2[ch] = countc+1) >= J_STEP0-1)
								goto err;
							if(!(flag & (MJ_EQ|MJ_EQL)))
								countc++;

						case MJ_I:
							j_table[ch] = J_IGNORE;
							continue;

						case MJ_BGET:
							flag &= ~MJ_TYPE;
							ad_bows[max_b] = ch;
							if(++max_b >= MJ_MAX_BOW)
								goto err;
							break;

						case MJ_S:
						case MJ_B:
						case MJ_0:
						case MJ_1:
							for(i = 0; i < max_j; i++){
								if(ch == j_stable2[i]){
									switch(flag & MJ_TYPE){
										case MJ_S:
											j_stable[i] = J_SKIP;
											break;

										case MJ_B:
											j_stable[i] = J_BOWEL;
											break;

										case MJ_0:
											j_stable[i] = J_NDAKU;
											break;

										case MJ_1:
											j_stable[i] = J_DAKU;
											break;
									}
									goto next_c;
								}
							}
							goto err;

						default:
							break;
					}
					if(!j_table[tmp] || !(flag & MJ_CONT)){
						j_table[tmp] = count;
						j_table2[tmp] = count1 + count2 + count3;
					}

					if( (count1 >= J_STEP0)
					  ||(count2 >= J_STEP1)
					  ||(count3 >= J_STEP2)) goto err;

					switch(depth){
						case 0:
							if(!(flag & (MJ_EQ|MJ_EQL))) count++;
							break;

						case 1:
							if(!(flag & (MJ_EQ|MJ_EQL))) count1+=J_STEP1;
							break;

						case 2:
							if(!(flag & (MJ_EQ|MJ_EQL))) count2+=J_STEP2;
							break;

						case 3:
							if(!count2 && !count3 && (flag & MJ_KANA)){
								if(count1 == 0)
									h_table0[max_h] = ch;
								else if(count1 == J_STEP1)
									h_table1[max_h] = ch;
							}
							if(!(flag & (MJ_EQ|MJ_EQL))) count3++;
							break;
					}
next_c:	/* */	}
				flag &= ~(MJ_EQ|MJ_CONT);
				break;
			}
		}
next_l:	
	}
end:
	j_k_end = j_k_start + max_h;
	for(i = 0; i < max_j; i++){
		ch = j_stable2[i];
		if(!(tmp = j_stable[i])){
			fprintf(stderr, "Error of KANA special in J-table\n");
				exit(2);
		}
		j_table[J_OSHIFT + i]  = j_table[ch];	/* shift contents in j_table */
		j_table2[J_OSHIFT + i] = j_table2[ch];
		j_table[ch] = 0x10 + i;
		if(tmp == J_SKIP){
			j_table[ch] |= J_SKIP;
			continue;
		}
		count2 = J_SHIFT + i;
		for(count = 0; count < max_h; count++){
			switch(tmp){
				case J_BOWEL:
					cho = h_tableb[count];
					for(count3 = 0; count3 < max_b; count3++){
						if(bows[count3] != cho) continue;
						j_table[count2] = ad_bows[count3];
						goto next_k;
					}
					j_table[count2] = J_OSHIFT + i;
					continue;

				case J_NDAKU:
					j_table[count2] = (h_table0[count])?
							h_table0[count]:(J_OSHIFT + i);
					break;

				case J_DAKU:
					j_table[count2] = (h_table1[count])?
							h_table1[count]:(J_OSHIFT + i);
					break;
			}
next_k:		count2 += (count2 & 0x10)?0xf0:0x10;
		}
	}
}


static uint j_kana(uint chv, uint cho)
{
	uint	chvo;
	if(chv & J_SKIP)
		return cho;

	chvo = j_table[cho];
	if(chvo < j_k_start || chvo >= j_k_end)
		return J_OSHIFT + (chv & J_SORD);

	chvo -= j_k_start;
	chv &= J_SORD;
	if(chvo & 1) chv |= 0x10;
	return (j_table[((chvo & 0xfe)<<7)+chv+J_SHIFT]);
}

int	strjcmp(uchar *str1, uchar *str2, int len1, int len2)
{
	uint	ch1, ch2, chv1, chv2, cho1, cho2;
	int		flag, flagc, flagd, flag2;

	cho1 = cho2 = flag = flagc = flagd = flag2 = 0;

	while(len1 > 0 && len2 > 0){
get1:
#ifdef	EUC
		if((ch1 = *str1++) >= 0x8e){
			if(ch1 >= 0x91 && ch1 <= 0xfe){
				ch1 = ((ch1 - 0x8f)<< 7) + (*str1++ & 0x7f);
				len1--;
			}else if(ch1 <= 0x8f){
				ch1 = ((ch1 - 0x8e)<< 7) + (*str1++ & 0x7f);
				len1--;
			}
		}
#else
		if((ch1 = *str1++) >= 0x81){
			if(ch1 <= 0x9f){
				ch1 = ((ch1 - 0x80)<<8) + *str1++;
					len1--;
			}else if(ch1 >= 0xe0 && ch1 <= 0xfc){
				ch1 = ((ch1 - 0xc0)<<8) + *str1++;
				len1--;
			}
		}
#endif
		if((chv1 = j_table[ch1]) < J_SMAX && chv1){
			if(chv1!=J_IGNORE){
				if(!(flagd & 1)){
					flagd |= 1;
					flag2 = -(chv1 & J_SORD) - 1;
				}
				ch1 = j_kana(chv1, cho1);
				chv1 = j_table[ch1];
			}
			if(chv1==J_IGNORE){
				if(!(flagd & 2)){
					flagd |= 2;
					flagc = j_table2[ch1];
				}
				if(--len1 > 0) goto get1;
			}
		}
get2:
#ifdef	EUC
		if((ch2 = *str2++) >= 0x8e){
			if(ch2 >= 0x91 && ch2 <= 0xfe){
				ch2 = ((ch2 - 0x8f)<< 7) + (*str2++ & 0x7f);
				len2--;
			}else if(ch1 <= 0x8f){
				ch2 = ((ch2 - 0x8e)<< 7) + (*str2++ & 0x7f);
				len2--;
			}
		}
#else
		if((ch2 = *str2++) >= 0x81){
			if(ch2 <= 0x9f){
				ch2 = ((ch2 - 0x80)<<8) + *str2++;
				len2--;
			}else if(ch2 >= 0xe0 && ch2 <= 0xfc){
				ch2 = ((ch2 - 0xc0)<<8) + *str2++;
				len2--;
			}
		}
#endif
		if((chv2 = j_table[ch2]) < J_SMAX && chv2){
			if(chv2!=J_IGNORE){
				if(!(flagd & 4)){
					flagd |= 4;
					flag2=(!flag2)?1:(-flag2 - (chv2 & J_SORD) - 1);
				}
				ch2 = j_kana(chv2, cho2);
				chv2 = j_table[ch2];
			}
			if(chv2==J_IGNORE){
				if(!(flagd & 8)){
					flagd |= 8;
					flagc -= j_table2[ch2];
				}
				if(--len2 > 0)	goto get2;
			}
		}
		if(chv1 != chv2)
			return ((chv1 > chv2)?MJ_L1:-MJ_L1);
		else if(!(flag & 1) && (ch1 != ch2 || flagd)){
			chv1 = j_table2[ch1];
			chv2 = j_table2[ch2];
			if((chv1 & ~J_ORD1) != (chv2 & ~J_ORD1))
				flag = (chv1 > chv2)? MJ_L2:-MJ_L2;
			else if(!(flag & 2)){
				if((chv1 & ~J_ORD2) != (chv2 & ~J_ORD2))
					flag = (chv1 > chv2)? MJ_L3:-MJ_L3;
				else if(!(flag & 4)){
					if(chv1 != chv2)
						flag = (chv1 > chv2)? MJ_L4:-MJ_L4;
					else if(flagc){
						flag = (flagc > 0)?MJ_L4:-MJ_L4;
					}
					else if(flag2)
						flag = (flag2 > 0)? MJ_L4:-MJ_L4;
					else
						flagd = 0;
				}
			}
		}
		cho1 = ch1;
		cho2 = ch2;
		len1--;
		len2--;
	}
	if(len1 != len2)
		return(len1>len2)?MJ_L1:-MJ_L1;
	return flag;
}

#else

static uchar *j_table3;
#define	MAX_JTBL 	0x100
#define	J_STEP0		0x0080
#define	J_STEP1		0x0001
#define	J_STEP2		0x0001
#define	J_STEP3		0x0001
#define	J_ORD0		(~0x007f)
#define	J_IGNORE	0x0080
#define	MJ_MAX_C	0x0080

void makeJtable(uchar *f)
{
	uint	i, ch, cho, count, count1, count2, count3, countc;
	uint	skip, depth, jline, flag, tmp;
	uchar	*s;
	FILE	*fp;

	ch = cho = count1 = count2 = count3 = countc = depth = jline = flag = 
	skip = 0;
	count = 2*J_STEP0;

	if((fp = read_open(f, "psort.tbl")) == NULL){
		fprintf(stderr, "Cannot open J-table file\n");
		exit(2);
	}
	j_table  = (unsigned short *)xmalloc(MAX_JTBL*sizeof(unsigned short));
	j_table2 = (uchar *)xmalloc(2*MAX_JTBL*sizeof(uchar));
	j_table3 = j_table2 + (MAX_JTBL*sizeof(uchar));
	for(i=0; i<MAX_JTBL;i++)
		j_table3[i] = j_table2[i] = j_table[i] = 0;

	while(fgets(reg_buf, REG_size, fp) != NULL){
		jline++;
		if(reg_buf[0] <= ' ')
			continue;
		flag &= ~MJ_LINE;
		if(reg_buf[REG_size-1]){
			fprintf(stderr, "Too long line in %s\n", fname);
			exit(1);
		}
		modify_reg(reg_buf, 3);
		cho = ch;
		for(s = &reg_buf[0] ; ; ){
			switch(ch = *s++){
				case '\\':
				  switch(ch = *s++){
					case 'C':
						flag |= MJ_C;
						goto top;

					case 'I':
						flag |= MJ_I;
top:					if((s - &reg_buf[0]) != 2){
err:						fprintf(stderr, 
							"Error in J-order file(%d):%s", jline, reg_buf);
							exit(2);
						}
						continue;

					case 'E':
						ch = MAX_JTBL -1;
						goto get_code;
/*
					case 'N':
						ch = max_n++;
						if(max_n & 0x20)
							max_n += 0xe0;
						goto get_code;
*/
					case '0':
						if((ch = *s++) != 'x' && ch != 'X')
							goto err;
						ch = 0;
						for(;;s++){
							if(isdigit(tmp = *s))
								ch = (ch << 4) + tmp - '0';
							else{
								tmp = (tmp | 0x20) - ('a' - 10);
								if(tmp >= 10 && tmp < 16)
									ch = (ch<<4) + tmp;
								else break;
							}
						}
					case '(':
					case '[':
					case ']':
					case '-':
					case '=':
					case ')':
					case '\\':
						goto get_code;

					case 0:
						goto err;
				}

			case '(':
				if(depth == 1){
					skip |= 2;
					depth++;
				}
				goto up;

			case '[':
				if(depth == 0){
					skip |= 1;
					depth++;
				}
up:				if(depth++ >= 3) goto err;
				if(count3){
					count3 = 0;
					count2++;
				}
				if(depth == 3) continue;
				if(count2){
					count2 = 0;
					count1++;
				}
				if(depth == 2) continue;
				if(count1){
					count++;
					count1=0;
				}
				continue;

			case ')':
				if(depth == 3  && (skip & 2)){
					depth--;
					skip &= ~2;
				}
				goto down;

			case ']':
				if(depth == 2 && (skip & 1)){
					depth--;
					skip &= ~1;
				}
down:			if(depth-- <= 0) goto err;
				if(depth == 2){
					count3 = 0;
					if((count2 += J_STEP2) >= J_STEP1)
						goto err;
				}else if(depth == 1){
					count2 = count3 = 0;
					if((count1 += J_STEP1) >= J_STEP0)
						goto err;
				}else{
					count1 = count2 = count3 = 0;
					count += J_STEP0;
				}
				continue;

			case '-':
				flag |= MJ_CONT;
				continue;

			case '=':
				flag |= ((s - &reg_buf[0]) == 1)?MJ_EQL:MJ_EQ;
				continue;

			case 0:
				goto next_l;

			default:
				if(ch <= ' ')
					continue;
			}
get_code:	if(ch >= MAX_JTBL)	goto err;
				tmp = (flag & MJ_CONT)?(cho + 1):ch;
				for( ; tmp <= ch; tmp++){
					swicth(flag & MJ_TYPE){
						case MJ_C:
							if((j_table2[tmp] = countc+1) >= 0xff)
								goto err;
							if(!(flag & (MJ_EQ|MJ_EQL)))
								countc++;

						case MJ_I:
							j_table[tmp] = J_IGNORE;
							continue;
					}
					if(!j_table[tmp] || !(flag & MJ_CONT)){
						j_table[tmp] = count + count1;
						j_table2[tmp] = count2;
						j_table3[tmp] = count3;
					}

					if( (count  >= 0xff00)||(count1 >= 0x0080)
					  ||(count2 >= 0x00ff)||(count3 >= 0x00ff))
						goto err;

					switch(depth){
						case 0:
							if(!(flag & (MJ_EQ|MJ_EQL))) count+=J_STEP0;
							break;

						case 1:
							if(!(flag & (MJ_EQ|MJ_EQL))) count1+=J_STEP1;
							break;

						case 2:
							if(!(flag & (MJ_EQ|MJ_EQL))) count2+=J_STEP2;
							break;

						case 3:
							if(!(flag & (MJ_EQ|MJ_EQL))) count3+=J_STEP3;
							break;
					}
next_c:	/* */	}
				flag &= ~(MJ_EQ|MJ_CONT);
				break;
		}
next_l:	
	}
}

int	strjcmp(uchar *str1, uchar *str2, int len1, int len2)
{
	uint	ch1, ch2, chv1, chv2;
	int		flag, flagc, flagd;

	flag = flagc = flagd = 0;

	for(flag = flag2 = 0; len1 > 0 && len2 > 0; len1--, len2--){
		while((chv1 = j_table[ch1=*str1++]) == J_IGNORE && --len1 > 0){
			if(!flagd){
				flagd = 1;
				flag_c = j_table2[ch1];
			}
		}
		while((chv2 = j_table[ch2=*str2++]) == J_IGNORE && --len2 > 0){
			if(flagd <= 1){
				flagd = 2;
				flag_c -= j_table2[ch2];
			}
		}
		if(ch1 == ch2 && !flagd)
			continue;

		if(!((chv1-chv2)&J_ORD0))
			return(chv1 > chv2)? MJ_L1:-MJ_L1;

		if(chv1 != chv2)
				flag = (chv1 > chv2)? MJ_L2:-MJ_L2;
		else if(!(flag & 2)){
			if(j_table2[ch1] != j_table2[ch2])
				flag = (j_table2[ch1] > j_table2[ch2])? MJ_L3:-MJ_L3;
			else if(!(flag & 4)){
				if(j_table3[ch1] != j_table3[ch2])
					flag = (j_table3[ch1] > j_table3[ch2])? MJ_L4:-MJ_L4;
				else if(flagc)
					flag = (flagc > 0)? MJ_L4:-MJ_L4;
				else
					flagd = 0;
			}
		}
	}
	if(len1 != len2)
		return(len1>len2)?MJ_L1:-MJ_L1;
	return flag;
}
#endif
