/*
 *							Paragraph Sort
 *						Written by SHIMA, 1994-95
 */

#define uchar   unsigned char
#define	uint	unsigned int
#define	BUFFER	uchar

#ifdef	MSDOS
typedef	long	SIZE;
#define	HUGEBUF	uchar huge
#define	MAX_INT	0x7fff
#else
typedef	int		SIZE;
#define	MAX_INT	0x7fffffff
#define	HUGEBUF	uchar
#endif

static void getnum( uchar *, FILE * );
static int lgets( int num );
void  findtop( uchar * );
void  usg( void );
static void  strisort( uchar *ptr[], int upper );
static void  strmsort( uchar *ptr[], int upper );
static void  make_table( uchar **, int );
static int compare( uchar *, uchar *);
static void makehead( uchar *, int );
static int checkEOL( int );
int readdata( int );
static int readparat( int );
static int readparae( int );
static int getline( BUFFER * );
static int samehead( uchar *, uchar * );
static void writehead( uchar *, SIZE  );
static void writeoneline( uchar * );
void writedata( int );
static void makename( int );
int modify_reg( uchar *, int );
static void skip_digit( uchar ** );
static int read_opt( uchar *, int );
static int conc_opt( uchar *);
static int get_opt( uchar *, int );
static void analyze_key( void );
static void chkHead( void );
static void print_sum( void );
static int define_key( uchar * );
static int get_key( uchar * );
static int next_key( void );
static void fopens( int, int );
static void fcloses( int, int );
static void sort( int );
static void open_out( void );
static void get_default( void );

uint	jtosj( uint );
int		to_jis(uchar *);
void	*xmalloc( int );
int		strjcmp(uchar *, uchar *, int, int );
void	makeJtable(uchar *);
FILE	*read_open(uchar *, uchar *);
void	makeJtable(uchar *);
int		strjcmp(uchar *, uchar *, int, int );
void	JISmodeWrite( void );
void	KmodeRead( void );

#ifdef	KANJI
static int	strmcmp( uchar *, uchar *, int, int, uchar *, int);
#else
static int	strmcmp( uchar *, uchar *, int, int, uchar *);
#endif
#ifdef MSDOS
static int opentext( int, char *[], int );
#endif

extern unsigned short	*j_table;
extern uchar	reg_buf[];
extern char		fname[];
extern FILE		*fp_out;
extern uchar	esc_kanji_in[];
extern uchar	esc_kanji_out[];
extern int		kana8;
extern int		f_jis;

#define	MJ_L0		0x1000
#define	MJ_L1		0x0100
#define	MJ_L2		0x0007
#define	MJ_L3		0x0006
#define	MJ_L4		0x0004

#if defined(JIS) && defined(SJIS)
#error JIS and SJIS are both defined
#endif

#ifndef	KANJI
#if defined(JIS) || defined(EUC)
#define	KANJI	1
#endif
#endif

#if	defined(JIS) && !defined(EUC)
#define	SJIS	1
#endif

#ifdef	JIS
#define	Fputs(x)	to_jis(x)
#else
#define	Fputs(x)	fputs(x, fp_out);
#endif

extern int 
#ifdef	EUC
to_euc(uchar *, int);
#else
to_euc(uchar *);
#endif

#define	THRESHOLD	10
#define	REG_size	512
#define	RE_msize	300
#define	MAX_ARG0	256
#define	MIN_LINE	0x80
#define	MAX_SCREEN	18

#define	J_TYPE		7
#define	J_EUC		0
#define	J_JIS		1
#define	J_SJIS		2
#define	J_Q			4
#define	J_CR		8
#define	JO_TYPE		0x70
#define	JO_EUC		0
#define	JO_JIS		0x10
#define	JO_SJIS		0x20
#define	JO_Q		0x40
#define	JO_CR		0x80
#define	J_QQ		0x1000
#define	J_Q7		0x2000

#define	J_KANAQ		1
#define	J_KANA8		2
#define	JO_KANA8	0x20

#define	EUC_KANA	0x8e
#define	KANA_IN		0x0e
#define	KANA_OUT	0x0f
#define	ESC			0x1b
#define	ESC_POS		2

